<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task37.30-60</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <div class = "text-center mt-3">
            <h2>F120 Quản trị Users</h2>
        </div>
        <div class = "form-group">
            <button class = "btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
        </div>
        
        <table id="user-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Id</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
    </div>
    <!-- Create user modal-->
    <div id="create-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Create New User</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">First name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-firstname">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Last name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-lastname">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Country</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-create-country">
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Customer Type</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-create-customer-type">
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                        </select>
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Subject</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-subject">
                        </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-create-user" class="btn btn-primary">Insert User</button>
                    <button type="button" id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
    
    <!-- Edit user modal-->
    <div id="edit-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Chi tiết User</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">First name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-firstname">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Last name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-lastname">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Subject</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-subject">
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Country</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-country">
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Customer Type</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-customer-type">
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Register Status</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-register-status">
                            <option value="New">New</option>
                            <option value="Accepted">Accepted</option>
                            <option value="Denied">Denied</option>
                        </select>
                        </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-update-user" class="btn btn-success">Update User</button>
                    <button type="button" id="btn-update-cancel" class="btn btn-success" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-user-modal">
        <div class="modal-dialog">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Confirm xóa user</h5>
                <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa user này không?</label>
            </div>
            <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
                <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
            </div>
        </div>
        </div>
    </div>
</body>
<script>
    "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json";

    // Biến toàn cục để lưu trữ id user đang đc update or delete. Mặc định = 0;
    var gUserId = 0;
    var gUserObj = {};

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    var gNameCol = ["id", "firstname", "lastname", "country", "subject","customerType", "registerStatus", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;
    var gUserTable =  $("#user-table").DataTable({
        columns: [
          {data: gNameCol[gUSER_ID_COL]},
          {data: gNameCol[gFIRST_NAME_COL]},
          {data: gNameCol[gLAST_NAME_COL]},
          {data: gNameCol[gCOUNTRY_COL]},
          {data: gNameCol[gSUBJECT_COL]},
          {data: gNameCol[gCUSTOMER_TYPE_COL]},
          {data: gNameCol[gREGISTER_STATUS_COL]},
          {data: gNameCol[gACTION_COL]}
            ],
        columnDefs: [ //định nghĩa các cột hiển thị
          { targets: gUSER_ID_COL,
            className: "text-center"},
          { targets: gACTION_COL,
            className: "text-center", 
            defaultContent: `
            <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
            },
        ]
      });
/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
$(document).ready(function(){
    onPageLoading();
});
//2-C: gán sự kiện thêm mới
$("#btn-add-user").on("click",function(){
    onBtnAddNewUserClick(this);
});
//gán sự kiện cho các nút trên create user modal
$("#btn-create-user").on("click",function(){
    onBtnCreateUserClick(this);
});

//3-U: gán sự kiện sửa
$("#user-table").on("click",".edit-user",function(){
    onBtnEditUserClick(this);
});
//gán sự kiện cho các nút trên update user modal
$("#btn-update-user").on("click",function(){
    onBtnUpdateUserClick(this);
});

//4-D: gán sự kiện nút xóa 
$("#user-table").on("click",".delete-user",function(){
    onBtnDeleteUserClick(this);
});
//gán sự kiện cho nút xác nhận xóa user modal
$("#btn-confirm-delete-user").on("click",function(){
    onBtnConfirmDeleteUserClick(this);
});

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading(){
    //1-R: Read /Load user to data table
    getAllUsers();
}
//hàm xử lý sự kiện ấn icon edit user
function onBtnEditUserClick(paramBtnEdit){
    //lưu thông tin user id vào biến toàn cục
    gUserId = getUserIdFromButton(paramBtnEdit);
    console.log("Id của user tương ứng: " + gUserId);
    //hiển thị modal lên
    $("#edit-user-modal").modal("show");
    loadUserDataToUserEditModal(gUserObj);
}
//hàm xử lý sự kiện ấn icon delete user
function onBtnDeleteUserClick(paramBtnDelete){
    $("#delete-user-modal").modal("show");
    //lưu thông tin user id vào biến toàn cục
    gUserId = getUserIdFromButton(paramBtnDelete);
    console.log("Id của user tương ứng: " + gUserId);
}
//hàm xử lý sự kiện ấn nút add user
function onBtnAddNewUserClick(){
   //hiển thị modal lên
   $("#create-user-modal").modal("show");
}
//hàm xử lý sự kiện nhấn nút create user trên modal
function onBtnCreateUserClick(){
    //khai báo đối tượn user obj
    var vObjectRequestData = {
        firstname:"",
        lastname: "",
        country: "",
        subject: "",
        customerType: ""
    }
    //b1: thu thập dữ liệu input trên modal
    getInsertUserData(vObjectRequestData);
    //b2: validate
    var vIsValid = validateUserData(vObjectRequestData);
    //b3: gọi API thêm user
    if(vIsValid){
        ajaxCreateUser(vObjectRequestData);
    };
}
//hàm xử lý sự kiện nhấn nút update user trên modal
function onBtnUpdateUserClick(){
    //khai báo đối tượn user obj
    var vObjectRequestData = {
        firstname:"",
        lastname: "",
        country: "",
        subject: "",
        customerType: "",
        registerStatus: ""
    }
    //b1: thu thập dữ liệu input trên modal
    getEditedUserData(vObjectRequestData);
    //b2: validate
    var vIsValid = validateUserData(vObjectRequestData);
    //b3: gọi API thêm user
    if(vIsValid){
        ajaxUpdateUser(vObjectRequestData);
    };
}

//hàm xử lý sự kiện xác nhận xóa user
function onBtnConfirmDeleteUserClick(){
    "use strict";
    //gọi API xóa user
    ajaxDeleteUser(gUserId);
}
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //load users to data table
    function loadDataToUserTable(paramUsers){
        gUserTable.clear();
        gUserTable.rows.add(paramUsers);
        gUserTable.draw();
    }

    //gọi API load all users
    function getAllUsers() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function(paramUsers){
                console.log(paramUsers);
                loadDataToUserTable(paramUsers);
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xác định user id từ button
    function getUserIdFromButton(paramButton){
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        gUserObj = vUserRowData;
        return vUserRowData.id;
    }
    //hàm đọc thông tin user data được thêm
    function getInsertUserData(paramUserObj){
        paramUserObj.firstname = $("#input-create-firstname").val().trim();
        paramUserObj.lastname = $("#input-create-lastname").val().trim();
        paramUserObj.country = $("#select-create-country").val();
        paramUserObj.subject = $("#input-create-subject").val();
        paramUserObj.customerType = $("#select-create-customer-type").val();
    }
    //hàm load thông tin user ban đầu lên modal
    function loadUserDataToUserEditModal(paramUserObj){
        $("#input-edit-firstname").val(paramUserObj.firstname);
        $("#input-edit-lastname").val(paramUserObj.lastname);
        $("#input-edit-subject").val(paramUserObj.subject);
        $("#select-edit-country").val(paramUserObj.country);
        $("#select-edit-customer-type").val(paramUserObj.customerType);
        $("#select-edit-register-status").val(paramUserObj.registerStatus);
    }
    //hàm đọc thông tin user data được edited
    function getEditedUserData(paramUserObj){
        paramUserObj.firstname = $("#input-edit-firstname").val();
        paramUserObj.lastname = $("#input-edit-lastname").val().trim();
        paramUserObj.country = $("#select-edit-country").val();
        paramUserObj.subject = $("#input-edit-subject").val();
        paramUserObj.customerType = $("#select-edit-customer-type").val();
        paramUserObj.registerStatus = $("#select-edit-register-status").val();
    }
    //hàm validate user data
    function validateUserData(paramUserObj){
        if (paramUserObj.firstname == "" ||
        paramUserObj.lastname == "" ||
        paramUserObj.subject == ""){
            alert("Cần nhập đầy đủ thông tin");
            return false;
        }
        return true;
    }
    //API thêm user
    function ajaxCreateUser(paramUserRequest){
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramUserRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleCreateUserSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi thêm user mới thành công
    function handleCreateUserSuccess(){
        alert("Thêm user thành công!");
        //reload data on table
        getAllUsers();
        resetUserForm();
        $("#create-user-modal").modal("hide");
    }
    //hàm xóa thông tin trên form create user modal
    function resetUserForm(){
        $("#input-create-firstname").val("");
        $("#input-create-lastname").val("");
        $("#input-create-subject").val("");
        $("#select-create-country").val("");
        $("#select-create-customer-type").val("");        
    };
    //API update user
    function ajaxUpdateUser(paramUserRequest){
        "use strict";
        $.ajax({
            url:  gBASE_URL + gUserId,
            type: "PUT",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramUserRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleUpdateUserSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi user cập nhật thành công
    function handleUpdateUserSuccess(){
        alert("Cập nhật user thành công!");
        //reload data on table
        getAllUsers();
        $("#edit-user-modal").modal("hide");
    }
    //API delete user
    function ajaxDeleteUser(paramUserId){
        "use strict";
        $.ajax({
            url:  gBASE_URL + gUserId,
            type: "DELETE",
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleDeleteUserSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi xóa user thành công
    function handleDeleteUserSuccess(){
        alert("Xóa user thành công!");
        //reload data on table
        getAllUsers();
        $("#delete-user-modal").modal("hide");
    }
</script>
</html>